<template lang="pug">
    #app
      .my-5.d-flex.justify-content-center(v-if="loading")
        spinner(text="Redirigiendo...")
      b-container.my-4.py-5(v-else fluid)
        router-view
</template>

<script lang="ts">
/* eslint-disable  @typescript-eslint/no-explicit-any */
import { Component, Vue, Watch } from "vue-property-decorator";
import { AxiosResponse } from "axios";
@Component
export default class HelloWorld extends Vue {
  loading = false;

  @Watch("$route", { immediate: true, deep: true })
  params(p: any) {
    if (p.query && p.query.uuid) {
      const lead_uuid = p.query.uuid;
      this.loadLeadData(lead_uuid);
      localStorage.setItem("LU", lead_uuid);
    }
  }

  created() {
    // this.loadLeadData(localStorage.getItem("LU") as string);
  }

  loadLeadData(lead_uuid: string) {
    if (lead_uuid) {
      this.loading = true;
      this.$onboardingService
        .getLead(lead_uuid)
        .then((res: AxiosResponse) => {
          // Cargamos en el store la información del Lead
          this.loadToState(res.data.process_state).then(() => {
            // Redireccionamos al paso en el que se quedó el usuario
            const path = `/paso${+res.data.step + 1}`;
            this.loading = false;
            if (
              this.$route.path !== path &&
              this.$route.path !== "/digital-error"
            ) {
              this.$router.push(path);
            }
          });
        })
        .catch((err: Error) => {
          this.loading = false;
          console.error(err);
          this.$bvToast.toast(`${err.message}`, {
            title: `Error`,
            autoHideDelay: 5000,
            variant: "danger",
          });
        });
    }
  }

  async loadToState(dataProcess: any) {
    await this.$store.dispatch("applicationStore/loadToState", dataProcess);
  }
}
</script>
